<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSmsNumbers ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSmsNumbers
 * @subpackage Arrays
 */
class ArrayOfSmsNumbers extends AbstractStructArrayBase
{
    /**
     * The SmsNumbers
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SmsNumbers[]
     */
    public $SmsNumbers;
    /**
     * Constructor method for ArrayOfSmsNumbers
     * @uses ArrayOfSmsNumbers::setSmsNumbers()
     * @param \StructType\SmsNumbers[] $smsNumbers
     */
    public function __construct(array $smsNumbers = array())
    {
        $this
            ->setSmsNumbers($smsNumbers);
    }
    /**
     * Get SmsNumbers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SmsNumbers[]|null
     */
    public function getSmsNumbers()
    {
        return isset($this->SmsNumbers) ? $this->SmsNumbers : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSmsNumbers method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSmsNumbers method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSmsNumbersForArrayConstraintsFromSetSmsNumbers(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSmsNumbersSmsNumbersItem) {
            // validation for constraint: itemType
            if (!$arrayOfSmsNumbersSmsNumbersItem instanceof \StructType\SmsNumbers) {
                $invalidValues[] = is_object($arrayOfSmsNumbersSmsNumbersItem) ? get_class($arrayOfSmsNumbersSmsNumbersItem) : sprintf('%s(%s)', gettype($arrayOfSmsNumbersSmsNumbersItem), var_export($arrayOfSmsNumbersSmsNumbersItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SmsNumbers property can only contain items of type \StructType\SmsNumbers, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SmsNumbers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SmsNumbers[] $smsNumbers
     * @return \ArrayType\ArrayOfSmsNumbers
     */
    public function setSmsNumbers(array $smsNumbers = array())
    {
        // validation for constraint: array
        if ('' !== ($smsNumbersArrayErrorMessage = self::validateSmsNumbersForArrayConstraintsFromSetSmsNumbers($smsNumbers))) {
            throw new \InvalidArgumentException($smsNumbersArrayErrorMessage, __LINE__);
        }
        if (is_null($smsNumbers) || (is_array($smsNumbers) && empty($smsNumbers))) {
            unset($this->SmsNumbers);
        } else {
            $this->SmsNumbers = $smsNumbers;
        }
        return $this;
    }
    /**
     * Add item to SmsNumbers value
     * @throws \InvalidArgumentException
     * @param \StructType\SmsNumbers $item
     * @return \ArrayType\ArrayOfSmsNumbers
     */
    public function addToSmsNumbers(\StructType\SmsNumbers $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SmsNumbers) {
            throw new \InvalidArgumentException(sprintf('The SmsNumbers property can only contain items of type \StructType\SmsNumbers, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SmsNumbers[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SmsNumbers|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SmsNumbers|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SmsNumbers|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SmsNumbers|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SmsNumbers|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SmsNumbers
     */
    public function getAttributeName()
    {
        return 'SmsNumbers';
    }
}
